*
* HBS240:   Accessory zum Ein- oder Ausschalten des
*           Cache im HBS240-Speeder.
*           kann auch als Programm gestartet werden.
*           Written  Jan. 1991  by  Bernd  Eckstein.
*           ========================================
* 
*   v0.9    07.12.1990
*   v1.00   08.12.1990  ;Prototyp: lauffhig mit Dialogboxen
*   v1.02   09.12.1990  ;sichern der Defaults im PRG
*   v1.10   07.01.1991  ;jetzt mit ResourceDatei
*   v1.11   11.01.1991  ;zwei kleine Fehler korrigiert
*   v1.15   12.01.1991  ;+ Resourcedatei intern
*   v1.16   14.04.1991  ;+ Korrekturen an der Resource
*   v1.17   12.05.1991  ;reagiert jetzt auf VA_START ($4711) von Gemini
*

vers        equ         '1'
rev1        equ         '1'
rev2        equ         '7'

G_BOX       equ         20
G_TEXT      equ         21
G_BOXTEXT   equ         22
G_IMAGE     equ         23
G_USERDEF   equ         24
G_IBOX      equ         25
G_BUTTON    equ         26
G_BOXCHAR   equ         27
G_STRING    equ         28
G_FTEXT     equ         29
G_FBOXTEXT  equ         30
G_ICON      equ         31
G_TITLE     equ         32

BTNMIDI     equ         2 
BTNKEYBD    equ         3 
BTNIOA7     equ         4 
BTNIOA6     equ         5 
BTNSAVE     equ         6 
BTNFPU      equ         10
BTNCPU      equ         11
BTNAUS      equ         14
BTNEIN      equ         15
TXTCACHE    equ         16
BTNOK       equ         17
BTNINFO     equ         18
BTNABORT    equ         20

sumTREES    equ         2           ; Anzahl aller Bume
OBJCs000    equ         13          ; Anzahl Objekte in Baum $000
OBJCs001    equ         21          ; Anzahl Objekte in Baum $001
sumOBJCS    equ         34          ; Summe aller Objekte

normal      equ         0
selected    equ         1
disabled    equ         8
shadowed    equ         32

unknown     equ         $10         ;ExeptionVector fr illegal Opcode
hz_200      equ         $4ba        ;200 Hz Zhler
CookiePtr   equ         $5a0
keyb_acia   equ         $FFFFFC00
keyb_init   equ         $96
midi_acia   equ         $FFFFFC04
midi_init   equ         $95
ym2149f     equ         $FFFF8800
port_a      equ         14
FPU_Base    equ         $FFFFFA40
FPU_control equ         FPU_Base+2
FPU_command equ         FPU_Base+$A
FPU_operand equ         FPU_Base+$10

saveBytes   equ         2

            macro       kennung
            dc.b        $BE,'hb1'
            endm

*****************************************************
*  Hier wird angegeben, welcher der vier mglichen  *
*  Ports zur Steuerung des Caches verwendet wird.   *
*  alle Ports sind beim Rechnerboot low             *
*                                                   *
*  port     equ         0  ;IOA6   (15)             *
*  port     equ         1  ;IOA7    (14)            *
*  port     equ         2  ;RTS Midi (5)            *
port        equ         3  ;RTS Keybd (5)           *
*                                                   *
*****************************************************

Start0:     bra.s       Start1

saveArea:
            dc.b        0
port_type:  dc.b        port

            dc.b        'v',vers,'.',rev1,rev2
            dc.b        ' written Jan \'91'
            dc.b        ' by Bernd Eckstein',13,10,0,$1a
            even

Start1:     lea         stack,a7                ; neuen Stack setzen
            lea         Start0-256(pc),a0       ; Begin of Basepage
            tst.l       $24(a0)                 ; existiert p_parent?
            beq.s       Start2                  ; nein, dann Accessory
            bsr         _LoadRsc
            tst.w       d0
            bmi.s       pxt
            bsr         _PrgPath
            bsr         _Do_It
            lea         rsrc_free(pc),a0        ; RSRC_FREE()
            bsr         _AES
       pxt: clr.w       -(sp)
            trap        #1                      ; Pterm0()

Start2:     bsr         _AccPath
            lea         appl_init(pc),a0
            bsr         _AES                     ; APPL_INIT()
            move.w      d0,ap_id
            bmi.s       axt
            move.w      d0,intin
            lea         acc_name(pc),a0
            move.l      a0,addrin
            lea         menu_reg(pc),a0
            bsr         _AES                    ; MENU_REGISTER()
            tst.w       d0
            bmi.s       axt
            bsr         _LoadRsc
            tst.w       d0
            bmi.s       axt

EventMsg:   lea         evnt_mesag(pc),a0
            move.l      #msg_buf,addrin
            bsr         _AES                    ; EVNT_MESAG(msg_buf)
            cmpi.w      #$4711,msg_buf          ; ist's VA_START?
            beq.s       do_it1
            cmpi.w      #40,msg_buf             ; ist's ACC_OPEN?
            bne.s       EventMsg                ; leider nicht
    do_it1: bsr.s       _Do_It
            bra.s       EventMsg

       axt: pea         AccError(pc)
            move.w      #9,-(sp)
            trap        #1
            addq.l      #6,sp
       axx: bra.s       axx

************************************************************
*
* ==>> DER eigentliche Kern, er kommt immer dran.
*
_Do_It:     move.w      #0,intin
            lea         graf_mouse(pc),a0
            bsr         _AES                    ;GRAF_MOUSE(arrow)

            pea         _CpuTest(pc)
            move.w      #38,-(sp)
            trap        #14                     ; _cpu=SupExec(_CpuTest)
            addq.l      #6,sp
            move.w      d0,_cpu

            pea         _FpuTest(pc)
            move.w      #38,-(sp)
            trap        #14                     ; _fpu=SupExec(_FpuTest)
            addq.l      #6,sp
            move.w      d0,_fpu

            pea         _CacheTest(pc)
            move.w      #38,-(sp)
            trap        #14                     ; _spd=SupExec(_CacheTest)
            addq.l      #6,sp
            move.b      d0,_spd


            move.w      #3,intin
            lea         wind_updat(pc),a0
            bsr         _AES                    ;~WIND_UPDATE(beg_mctrl)

            move.l      tree1(pc),addrin
            lea         form_centr(pc),a0
            bsr         _AES                    ;xywh1=FORM_CENTER(tree1)
            lea         xywh1(pc),a0
            lea         intout+2,a1
            move.l      (a1)+,(a0)+
            move.l      (a1),(a0)

            moveq       #0,d0
            lea         xywh1(pc),a0
            lea         xywh1(pc),a1
            bsr         _FormDial               ;FORM_DIAL(fmd_start)

            tst.w       _cpu
            bne.s       di1
            moveq       #BTNCPU,d0              ;ist eine 68000
            moveq       #shadowed,d1
            bsr         Ochng1

       di1: cmpi.b      #$c,_spd
            ble.s       di3                     ;kein Speeder da
            moveq       #TXTCACHE,d0
            moveq       #normal,d1
            bsr         Ochng1

            cmpi.b      #$19,_spd
            bpl.s       di2
            moveq       #BTNAUS,d0              ;Speeder da, Cache aus
            moveq       #selected,d1
            bsr         Ochng1
            moveq       #BTNEIN,d0
            moveq       #normal,d1
            bsr         Ochng1
            bra.s       di3

       di2: move.w      #BTNAUS,d0              ;Speeder da, Cache ein
            moveq       #normal,d1
            bsr         Ochng1
            move.w      #BTNEIN,d0
            moveq       #selected,d1
            bsr         Ochng1

       di3: tst.w       _fpu
            beq.s       di4
            moveq       #BTNFPU,d0              ;ist eine 68881
            moveq       #shadowed,d1
            bsr         Ochng1

       di4: move.b      _por(pc),d0
            add.w       d0,d0
            lea         porttable(pc),a0
            move.w      (a0,d0),d0
            moveq       #selected+shadowed,d1
            bsr         Ochng1



       dl0: move.l      tree1(pc),addrin
            lea         intin,a0
            move.w      #0,(a0)+
            move.w      #6,(a0)+
            lea         xywh1(pc),a1
            move.l      (a1)+,(a0)+
            move.l      (a1),(a0)
            lea         objc_draw(pc),a0
            bsr         _AES                    ;OBJC_DRAW(tree0)

       dl1: move.l      tree1(pc),addrin
            move.w      #0,intin
            lea         form_do(pc),a0
            bsr         _AES                    ;FORM_DO(tree0)
            move.w      d0,-(sp)
            moveq       #normal,d1
            bsr         Ochng1
            move.w      (sp)+,d0

            cmpi.w      #BTNABORT,d0            ;Programm abbrechen ?
            beq.s       dl2
            cmpi.w      #BTNOK,d0               ;Programm beenden ?
            bne.s       dl3
            bsr         set_them                ;Einstellungen bernehmen
       dl2: 
            moveq       #3,d0
            lea         xywh1(pc),a0
            lea         xywh1(pc),a1
            bsr         _FormDial               ;FORM_DIAL(fmd_finish)
            move.w      #2,intin
            lea         wind_updat(pc),a0
            bra         _AES                    ;~WIND_UPDATE(end_mctrl)
            ;Hier ist das Programm fertig...

       dl3: cmpi.w      #BTNINFO,d0             ;Infobox anzeigen ?
            bne.s       dl4
            moveq       #normal,d1
            bsr         Ochng1
            bsr         _Do_Info
            bra         dl0

       dl4: cmpi.w      #BTNSAVE,d0             ;Einstellungen sichern ?
            bne.s       dl1
            moveq       #normal,d1
            bsr         Ochng1
            bsr         set_them
            bsr         _SaveSetup
            bra         dl0

porttable:  dc.w        BTNIOA6,BTNIOA7,BTNMIDI,BTNKEYBD

*
*  Auswertung der Radiobuttons
*
set_them:   lea         porttable(pc),a0    ;Zuordnung Objekt# <-> Port#
            move.l      tree1(pc),a1
            moveq       #3,d7               ;max vier Portbuttons
            moveq       #-1,d6
      stl1: addq.l      #1,d6               ;Port#-Zhler
            moveq       #0,d0
            move.w      (a0)+,d0            ;Objekt#(Port#)
            mulu        #24,d0
            lea         (a1,d0),a6
            move.w      10(a1,d0),d0
            andi.w      #selected,d0        ;=selected?
            bne.s       stl2                ;ja, Port# merken
            dbra        d7,stl1
      stl2: move.b      d6,_por
            move.b      d6,port_type

      stl3: moveq       #0,d0
            move.w      #BTNEIN,d0
            mulu        #24,d0
            move.w      10(a1,d0),d0
            andi.w      #selected,d0
            bne.s       stl4
            pea         _Cache_Aus(pc)
            bra.s       stl5
      stl4: pea         _Cache_Ein(pc)
      stl5: move.w      #38,-(sp)
            trap        #14                     ;SupExec(_Cache_xxx)
            addq.l      #6,sp
            rts

*
*  Setzen des Statuses d1 in Object d0 des Baumes 1
*
Ochng1:     move.l      tree1(pc),a0
            lea         xywh1(pc),a1
            bra         _ObjcChng



************************************************************
*                                                          *
*           Hier sind die Unterprogramme.......            *
*                                                          *
************************************************************

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

************************************************************
*
*  Zentrieren, Zeichnen und Erledigen der InfoBox
*

_Do_Info:   move.l      tree0(pc),addrin
            lea         form_centr(pc),a0
            bsr         _AES                    ;xywh0=FORM_CENTER(tree0)
            lea         xywh0(pc),a0
            lea         intout+2,a1
            move.l      (a1)+,(a0)+
            move.l      (a1),(a0)

            move.l      tree0(pc),addrin
            lea         intin,a0
            move.w      #0,(a0)+
            move.w      #6,(a0)+
            lea         xywh0(pc),a1
            move.l      (a1)+,(a0)+
            move.l      (a1),(a0)
            lea         objc_draw(pc),a0
            bsr         _AES                    ;OBJC_DRAW(tree0)

            move.l      tree0(pc),addrin
            move.w      #0,intin
            lea         form_do(pc),a0
            bsr         _AES                    ;FORM_DO(tree0)

            moveq       #0,d1
            lea         xywh0(pc),a1
            move.l      tree0(pc),a0
            bra         _ObjcChng               ;OBJC_CHNG(d0,a0,a1)


************************************************************
*
*  Einladen von 'CACHE.RSC', sowie Ermitteln
*  der beiden Objektbaumadressen.
*

_LoadRsc:   move.b      port_type(pc),_por

            lea         Objc000000(pc),a6       ;Baum 000
            moveq       #OBJCs000-1,d6          ;Anzahl der Objekte
    Obfix0: movem.l     a6/d6,-(sp)
            move.l      a6,addrin
            move.w      d6,intin
            lea         rsrc_obfix(pc),a0
            bsr         _AES
            movem.l     (sp)+,a6/d6
            dbra        d6,Obfix0

            lea         Objc001000(pc),a6       ;Baum 001
            moveq       #OBJCs001-1,d6          ;Anzahl der Objekte
    Obfix1: movem.l     a6/d6,-(sp)
            move.l      a6,addrin
            move.w      d6,intin
            lea         rsrc_obfix(pc),a0
            bsr         _AES
            movem.l     (sp)+,a6/d6
            dbra        d6,Obfix1

            rts

************************************************************
*
*  Schaltet das Portbit, das in port_type
*  spezifiziert wird, auf Low.
*

_Cache_Ein: move.b      _por(pc),d0
            lea         ym2149f.w,a0
            move        sr,d7
            ori         #$700,sr
            tst.b       d0
            bne.s       ce1
            move.b      #port_a,(a0)            ;typ0
            move.b      (a0),d0
            bclr        #6,d0
            move.b      d0,2(a0)
            bra.s       cex
       ce1: cmpi.b      #1,d0
            bne.s       ce2
            move.b      #port_a,(a0)            ;typ1
            move.b      (a0),d0
            bclr        #7,d0
            move.b      d0,2(a0)
            bra.s       cex
       ce2: cmpi.b      #3,d0
            bne.s       ce3
            move.b      #midi_init,midi_acia.w  ;typ2
            bra.s       cex
       ce3: move.b      #keyb_init,keyb_acia.w  ;typ3
       cex: move        d7,sr
            rts

************************************************************
*
*  Schaltet das Portbit, das in port_type
*  spezifiziert wird, auf High.
*

_Cache_Aus: move.b      _por(pc),d0
            lea         ym2149f.w,a0
            move        sr,d7
            ori         #$700,sr
            tst.b       d0
            bne.s       ca1
            move.b      #port_a,(a0)            ;typ0
            move.b      (a0),d0
            bset        #6,d0
            move.b      d0,2(a0)
            bra.s       cax
       ca1: cmpi.b      #1,d0
            bne.s       ca2
            move.b      #port_a,(a0)            ;typ1
            move.b      (a0),d0
            bset        #7,d0
            move.b      d0,2(a0)
            bra.s       cax
       ca2: cmpi.b      #3,d0
            bne.s       ca3
            move.b      #midi_init+$40,midi_acia.w      ;typ2
            bra.s       cax
       ca3: move.b      #keyb_init+$40,keyb_acia.w      ;typ3
       cax: move        d7,sr
            rts

************************************************************


************************************************************
*
*  CacheTest testet, ob Cache vorhanden, und eingeschaltet.
*
*  Rckgabewert in d0.l:  8 MHz: $0C
*                        16 MHz: $13
*                        +Cache: $19
*

_CacheTest: lea         hz_200.w,a0
     CacT1: move.l      (a0),d1
            andi.w      #$F,d1
            bne.s       CacT1
     CacT2: move.l      (a0),d1
            andi.w      #$f,d1
            beq.s       CacT2
            clr.l       d0
     CacT3: moveq.l     #1,d7
            addq.l      #1,d0
            move.l      (a0),d1
            divu        d7,d7
            andi.w      #$F,d1
            bne.s       CacT3
            lsr.l       #8,d0
            rts

************************************************************
*  
*  Der CPU-Test versucht einen move CCR,d0. Diesen gibt's
*  nicht beim 68000,  so dass eine Exeption erzeugt wird.
*  Bei allen anderen Typen klappt's, also keine Exeption.
*
*  liefert(d0.l = 0 wenn 68000, sonst = 1
*

_CpuTest:   lea         CpuT1(pc),a0
            move.l      unknown.w,a4
            move.l      a0,unknown.w
            dc.w        $42c0          ;move CCR,d0
            move.l      a4,unknown.w
            moveq       #1,d0
            rts
     CpuT1: move.l      a4,unknown.w
            addq.l      #6,sp
            moveq       #0,d0
            rts

************************************************************
*  
*  Der FPU-Test versucht $FFFFFA40 anzusprechen, wenn
*  es geht, stoppt dann die FPU und lscht den Operanden.
*
*  liefert: d0.l =1, wenn FPU vorhanden, sonst 0
*  

_FpuTest:   lea         old_Berr(pc),a0
            move.l      $8.w,(a0)+
            move.l      a0,$8.w

            movea.l     sp,a0 
            tst.w       FPU_Base        ;FPU accessible ?
            move.w      #3,FPU_control  ;Abort Command senden
     FpuT1: cmpi.w      #$0802,FPU_Base ;wait for idle Base
            bne.s       FpuT1
            clr.l       FPU_operand
            moveq       #1,d0
     FpuT2: move.l      old_Berr(pc),$8.w
            rts

            dc.b        'XBRA'
            kennung
old_Berr:   dc.l        0
            movea.l     a0,sp
            moveq       #0,d0
            bra.s       FpuT2

************************************************************

_PrgPath:   move.l      #filepath,addrin
            move.l      #intout+4,addrin+4
            lea         shel_read(pc),a0
            bra         _AES

_AccPath:   pea         sap(pc)
            move.w      #38,-(sp)
            trap        #14
            addq.l      #6,sp
            addi.b      #'A',d0
            move.b      d0,filepath
            rts
       sap: move.w      $446.w,d0
            rts

************************************************************

_SaveSetup: move.w      #1,-(sp)
            pea         filepath(pc)
            move.w      #61,-(sp)
            trap        #1          ;Fopen(filepath,write)
            addq.l      #8,sp
            move.w      d0,d7
            bmi.s       file_err

            clr.w       -(sp)
            move.w      d7,-(sp)
            move.l      #30,-(sp)
            move.w      #66,-(sp)
            trap        #1          ;Fseek(31,d7,absolute)
            lea         10(sp),sp
            tst.l       d0
            bmi.s       file_err

            pea         saveArea(pc)
            move.l      #saveBytes,-(sp)
            move.w      d7,-(sp)
            move.w      #64,-(sp)
            trap        #1
            lea         12(sp),sp
            cmpi.l      #saveBytes,d0
            beq.s       fclose

  file_err: move.w      d7,-(sp)
            lea         FileErrBox(pc),a0
            moveq       #1,d0
            bsr         _Alert
            move.w      (sp)+,d7

    fclose: move.w      d7,-(sp)
            move.w      #62,-(sp)
            trap        #1          ;Fclose(d7)
            addq.l      #4,sp
            rts



************************************************************
*
* Up zum Aufruf des AES
*
_ObjcChng:  move.l      a0,addrin               ; d0:   Object#
            lea         intin,a0                ; d1:   new_state
            move.w      d0,(a0)+                ; a0: ->Ob_tree
            clr.w       (a0)+                   ; a1: ->xywh
            move.l      (a1)+,(a0)+
            move.l      (a1),(a0)+
            move.w      d1,(a0)+
            move.w      #1,(a0)
            lea         objc_chng(pc),a0
            bra.s       _AES
_FormDial:  lea         intin,a2                ; d0:   fo_diflag
            move.w      d0,(a2)+                ; a0: ->fo_dilitt
            move.l      (a0)+,(a2)+             ; a1: ->fo_dibig
            move.l      (a0),(a2)+
            move.l      (a1)+,(a2)+
            move.l      (a1),(a2)
            lea         form_dial(pc),a0
            bra.s       _AES
_Alert:     move.l      a0,addrin               ; d0:   fo_adefbttn
            move.w      d0,intin                ; a0: ->fo_astring
            lea         form_alert(pc),a0
_AES:       lea         aespb(pc),a1    ;Adr. cntrl in den 
            move.l      a0,(a1)        ;aespb eintragen
            move.l      a1,d1            ;Adr. aespb nach d1
            move.w      #200,d0
            trap        #2               ;ruft das AES
            move.w      intout,d0
            rts

********************************
*
* ==>> Datenfelder fr's AES, u.......
*
aespb:      dc.l        0,global,intin,intout,addrin,addrout
appl_init:  dc.w        10,0,1,0,0
appl_exit:  dc.w        19,0,1,0,0
evnt_mesag: dc.w        23,0,1,1,0
menu_reg:   dc.w        35,1,1,1,0
objc_draw:  dc.w        42,6,1,1,0
objc_chng:  dc.w        47,8,1,1,0
form_do:    dc.w        50,1,1,1,0
form_dial:  dc.w        51,9,1,0,0
form_alert: dc.w        52,1,1,1,0
form_centr: dc.w        54,0,5,1,0
graf_mouse: dc.w        78,1,1,1,0
wind_updat: dc.w        107,1,1,0,0
rsrc_load:  dc.w        110,0,1,1,0
rsrc_free:  dc.w        111,0,1,0,0
rsrc_saddr: dc.w        113,2,1,1,0
rsrc_obfix: dc.w        114,1,1,1,0
shel_read:  dc.w        120,0,1,2,0

FileErrBox: dc.b        '[1][ |Fehler beim Sichern|'
            dc.b        ' der Einstellungen][ Mist ]',0
AccError:   dc.b        '    Fehler beim Installieren von HBS240.ACC',10,13
            dc.b        '    System wurde angehalten...',10,13,0
acc_name:   dc.b        '  HBS240 v',vers,'.',rev1,rev2,0
filepath:   dc.b        '#:\\HBS240.ACC'  ;Platz fr Pfad und Dateinamen,
            dcb.b       120,0             ;Default fr den Acc-Betrieb.
            even

tree0:      dc.l        Objc000000
tree1:      dc.l        Objc001000

xywh0:      dcb.w       4,0
xywh1:      dcb.w       4,0



*******
*  -->>  Objektbaum $0
Objc000000: dc.w        $FFFF,$0001,$000C,G_BOX,$0000,$0010
            dc.l        $00023121
            dc.w        $0001,$0001,$002D,$0811
Objc000001: dc.w        $0002,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec000001
            dc.w        $0003,$0001,$0026,$0001
Objc000002: dc.w        $0003,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec000002
            dc.w        $0003,$0002,$0026,$0001
Objc000003: dc.w        $0009,$0004,$0008,G_BOX,$0000,$0010             ;;
            dc.l        $00023102
            dc.w        $0003,$0003,$0026,$0808
Objc000004: dc.w        $0005,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec000004
            dc.w        $000B,$0006,$000F,$0001
Objc000005: dc.w        $0006,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec000005
            dc.w        $000B,$0005,$000F,$0001
Objc000006: dc.w        $0007,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec000006
            dc.w        $0003,$0001,$0020,$0001
Objc000007: dc.w        $0008,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec000007
            dc.w        $0009,$0002,$0013,$0001
Objc000008: dc.w        $0003,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec000008
            dc.w        $000C,$0003,$000D,$0001
Objc000009: dc.w        $000A,$FFFF,$FFFF,G_BUTTON,$0007,$0000
            dc.l        spec000009
            dc.w        $0014,$0010,$0006,$0001
Objc00000A: dc.w        $000B,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec00000A
            dc.w        $0003,$0003,$0026,$0001
Objc00000B: dc.w        $000C,$FFFF,$FFFF,G_STRING,$0000,$0000
            dc.l        spec00000B
            dc.w        $0003,$0004,$0026,$0001
Objc00000C: dc.w        $0000,$FFFF,$FFFF,G_TEXT,$0020,$0000
            dc.l        spec00000C
            dc.w        $0006,$000B,$0021,$0001             ;;

*******
*  -->>  Objektbaum $1
Objc001000: dc.w        $FFFF,$0001,$0014,G_BOX,$0000,$0010
            dc.l        $00023121
            dc.w        $0001,$0001,$002D,$0811
Objc001001: dc.w        $0009,$0002,$0008,G_BOX,$0000,$0020
            dc.l        $00FF3102
            dc.w        $001B,$0001,$000F,$000D
Objc001002: dc.w        $0003,$FFFF,$FFFF,G_BUTTON,$0011,$0020
            dc.l        spec001002
            dc.w        $0003,$0008,$0009,$0001
Objc001003: dc.w        $0004,$FFFF,$FFFF,G_BUTTON,$0011,$0020
            dc.l        spec001003
            dc.w        $0003,$0006,$0009,$0001
Objc001004: dc.w        $0005,$FFFF,$FFFF,G_BUTTON,$0011,$0020
            dc.l        spec001004
            dc.w        $0003,$0004,$0009,$0001
Objc001005: dc.w        $0006,$FFFF,$FFFF,G_BUTTON,$0011,$0020
            dc.l        spec001005
            dc.w        $0003,$0002,$0009,$0001
Objc001006: dc.w        $0007,$FFFF,$FFFF,G_BUTTON,$0005,$0000
            dc.l        spec001006
            dc.w        $0003,$000B,$0009,$0001
Objc001007: dc.w        $0008,$FFFF,$FFFF,G_TEXT,$0000,$0000
            dc.l        spec001007
            dc.w        $0002,$0000,$000B,$0001
Objc001008: dc.w        $0001,$FFFF,$FFFF,G_TEXT,$0000,$0000
            dc.l        spec001008
            dc.w        $0002,$000A,$000B,$0001
Objc001009: dc.w        $0011,$000A,$000D,G_BOX,$0000,$0020
            dc.l        $00FF3102
            dc.w        $0003,$0001,$0016,$000D
Objc00100A: dc.w        $000B,$FFFF,$FFFF,G_BUTTON,$0000,$0028
            dc.l        spec00100A
            dc.w        $0004,$0009,$000E,$0002
Objc00100B: dc.w        $000C,$FFFF,$FFFF,G_BUTTON,$0000,$0028
            dc.l        spec00100B
            dc.w        $0004,$0002,$000E,$0002
Objc00100C: dc.w        $000D,$FFFF,$FFFF,G_TEXT,$0000,$0000
            dc.l        spec00100C
            dc.w        $0006,$0000,$040A,$0001
Objc00100D: dc.w        $0009,$000E,$0010,G_BOX,$0000,$0020
            dc.l        $00FF1101
            dc.w        $0002,$0005,$0012,$0003
Objc00100E: dc.w        $000F,$FFFF,$FFFF,G_BUTTON,$0011,$0000
            dc.l        spec00100E
            dc.w        $000C,$0001,$0004,$0001
Objc00100F: dc.w        $0010,$FFFF,$FFFF,G_BUTTON,$0011,$0000
            dc.l        spec00100F
            dc.w        $0008,$0001,$0004,$0001
Objc001010: dc.w        $000D,$FFFF,$FFFF,G_STRING,$0000,$0008
            dc.l        spec001010
            dc.w        $0001,$0001,$0006,$0001
Objc001011: dc.w        $0012,$FFFF,$FFFF,G_BUTTON,$0007,$0000
            dc.l        spec001011
            dc.w        $001F,$000F,$0008,$0001
Objc001012: dc.w        $0013,$FFFF,$FFFF,G_BUTTON,$0005,$0000
            dc.l        spec001012
            dc.w        $0013,$000F,$0007,$0001
Objc001013: dc.w        $0014,$FFFF,$FFFF,G_TEXT,$0000,$0000
            dc.l        spec001013
            dc.w        $000E,$0000,$0413,$0001
Objc001014: dc.w        $0000,$FFFF,$FFFF,G_BUTTON,$0025,$0000
            dc.l        spec001014
            dc.w        $0006,$000F,$0008,$0001

*******
*  -->>  Objektinhalte
*  -->>  Objektbaum $0
spec000001: dc.b        0

spec000002: dc.b        0

spec000004: dc.b        'Fax: 0241/35246',0

spec000005: dc.b        'Tel: 0241/35247',0

spec000006: dc.b        'Heyer & Neumann Hardwarebro GbR',0

spec000007: dc.b        'Promenadenstrae 50',0

spec000008: dc.b        'W 5100 Aachen',0

spec000009: dc.b        'OK',0

spec00000A: dc.b        0

spec00000B: dc.b        0

            even        ; TedInfo 00000C
spec00000C: dc.l        te_t00000C,te_m00000C,te_v00000C
            dc.w        $0005,$0006,$0002,$1180,$0000,$FFFF,$002A,$0001
te_t00000C: dc.b        ' Programm geschrieben von Bernd Eckstein ',0
te_m00000C: dc.b        0
te_v00000C: dc.b        0

*  -->>  Objektbaum $1
spec001002: dc.b        'Midi',0

spec001003: dc.b        'KeyBd',0

spec001004: dc.b        'IOA 7',0

spec001005: dc.b        'IOA 6',0

spec001006: dc.b        'Sichern',0

            even        ; TedInfo 001007
spec001007: dc.l        te_t001007,te_m001007,te_v001007
            dc.w        $0005,$0006,$0002,$1180,$0000,$FFFF,$000F,$0001
te_t001007: dc.b        'benutzter Port',0
te_m001007: dc.b        0
te_v001007: dc.b        0

            even        ; TedInfo 001008
spec001008: dc.l        te_t001008,te_m001008,te_v001008
            dc.w        $0005,$0006,$0002,$1180,$0000,$FFFF,$000E,$0001
te_t001008: dc.b        'Einstellungen',0
te_m001008: dc.b        0
te_v001008: dc.b        0

spec00100A: dc.b        'FPU: 68881',0

spec00100B: dc.b        'CPU: 68000',0

            even        ; TedInfo 00100C
spec00100C: dc.l        te_t00100C,te_m00100C,te_v00100C
            dc.w        $0005,$0006,$0002,$1180,$0000,$FFFF,$000F,$0001
te_t00100C: dc.b        'Speeder Status',0
te_m00100C: dc.b        0
te_v00100C: dc.b        0

spec00100E: dc.b        'Aus',0

spec00100F: dc.b        'Ein',0

spec001010: dc.b        'Cache:',0

spec001011: dc.b        'OK',0

spec001012: dc.b        'Info',0

            even        ; TedInfo 001013
spec001013: dc.l        te_t001013,te_m001013,te_v001013
            dc.w        $0005,$0006,$0002,$1180,$0000,$FFFF,$001B,$0001
te_t001013: dc.b        ' HBS 240 - Statusschalter ',0
te_m001013: dc.b        0
te_v001013: dc.b        0

spec001014: dc.b        'Abbruch',0



            even
KeksListe:  dc.b        '_CPU'
      _cpu: dc.w        0,0
            dc.b        '_FPU'
      _fpu: dc.w        0,0
            kennung
      _spd: dc.b        0
      _por: dc.b        0
      _std: dc.b        0
      _fre: dc.b        0
            dc.l        0
            dc.l        8
            bss
            ds.l        32
msg_buf:    ds.w        8
ap_id:      ds.w        1
global:     ds.w        15
intin:      ds.w        128
intout:     ds.w        128
addrin:     ds.l        9 
addrout:    ds.l        9
            ds.l        $FF         ; 1kB fr den Stack
stack:      ds.l        1


